//+------------------------------------------------------------------+
//|                                                          PIN.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "2.00"
#property strict
#property indicator_chart_window

extern int SignalPin= 6; // EAX signal pin
extern ENUM_TIMEFRAMES RunTF = 15; // Signaling timeframe;
extern int SignalDelay=1;
extern int ReadDelay=2;
extern string strGridcheck="=============MIN GRID==============";
extern int GridPips=15; //Minimum Pips dist between trades'

extern string strSelectEntries="=============Entry Options==============";
extern bool TradeTrend=true;
extern bool TradeRad=false;
extern bool TradeWave=false;
extern bool TradeRange=false;



extern bool SignalClose= true; // Bar close changes signal
//extern bool SignalChange= true; // Only signal once cross bar 

extern string Req_indi="HGI_v16.09";

extern int    BarCount=100;        /* Bar Count */  // 0 for full chart buffer
//extern int    Risk=6;            /* Risk */  // Risk level. WPR_Period=3+Risk*2 or WPR_Period=ALT_PERIOD for a large move 

//extern int    Alert_OnBar=1;     /* Alert - On change of this Bar */ // Alert when this bar changes. = for curent bar, 1 for last closed bar
//extern bool   Alert_Popup=False; /* Alert - Popup Msg */ // Enable popup window & sound on alert
//extern string Alert_SoundUp="";  /* Alert - Play Sound File for Buy Signal */ // Play sound on alert. Wav files only
//extern string Alert_SoundDn="";  /* Alert - Play Sound File for Sell Signal */ // Play sound on alert. Wav files only
//extern bool   Alert_Email=False; /* Alert - Send eMail */ // Enable send email on alert
//extern string Alert_Subject=""; 




bool isiCustom=true;



/*
extern string rsistring="========================RSI FILTER=====================";
extern bool USERSI=true;
extern int RSI_period=2;
extern int RSITF=0;
extern int RSI_OverBought=70; // Enter Upper Limit of RSI
extern int RSI_OverSold=30; //Enter Lower Limit of RSI
*/

string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY"};// 28 pairs
//string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY" };// 28 pairs

string suffix = StringSubstr(Symbol(),6,0);
int offset = ((SignalClose) ? 1 : 0);
int signal,i;


//=====================================
double ma1,atr1,MinPriceDist;
int currentdist;
bool isWithinTradeZone,ExceedMinDist;
double pipPoint;
double  multiplier;

//======================================
double ma,open,close;

double trendbuy,trendsell, rangebuy, rangesell,radbuy, radsell, yellow_wave,bluewave;

#define NONE 0
#define CROSSUP 1
#define CROSSDOWN 2
#define ABOVE 1
#define BELOW 2
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  
    if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   
   
   EventSetMillisecondTimer(ReadDelay*1000); //100 before
   if (BarCount<1 || BarCount>Bars) 
    BarCount=Bars-12;

  //gbInit=True;
  return(0);
  
   return(INIT_SUCCEEDED);
  }
  
  
  
  //+------------------------------------------------------------------+
//| Unit                        |
//+------------------------------------------------------------------+  
  int deinit()
  {
   
   for (i=0;i<28;i++){
   GlobalVariableSet(symbols[i]+"pin"+SignalPin,NONE);
   }
   return (0);
   
   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnTimer() {
   
   for (i=0;i<28;i++) {
      //RSI_sig=iRSI(Symbol(),RSITF,RSI_period,PRICE_CLOSE,SignalDelay+0);
      
    //  ma = iMA(symbols[i]+suffix,RunTF,MAperiod,0,MAmethod,MAappliedprice,1);
     // open = iClose(symbols[i]+suffix,RunTF,offset);
     // close = iClose(symbols[i]+suffix,RunTF,offset);.;`w
      
     //double trend,rad,bluewave,yellow_wave;
     
     
           
     ExceedMinDist =false;
     
     if (TradeTrend){
      
      trendbuy=iCustom(symbols[i]+suffix,RunTF,"HGI_v16.09",isiCustom,0,SignalDelay+0);
      trendsell=iCustom(symbols[i]+suffix,RunTF,"HGI_v16.09",isiCustom, 1,SignalDelay+0);
     }//trend
     if (TradeRange){
      rangebuy=iCustom(symbols[i]+suffix,RunTF,"HGI_v16.09",isiCustom,  2,SignalDelay+0);
      rangesell=iCustom(symbols[i]+suffix,RunTF,"HGI_v16.09",isiCustom,  3,SignalDelay+0);
      }//range
     if (TradeRad){ 
         radbuy=iCustom(symbols[i]+suffix,RunTF,"HGI_v16.09",isiCustom, 4,SignalDelay+0);
         radsell=iCustom(symbols[i]+suffix,RunTF,"HGI_v16.09",isiCustom,  5,SignalDelay+0);
      }//rad
      
      
     if (TradeWave){
       yellow_wave=iCustom(symbols[i]+suffix,RunTF,"HGI_v16.09",  6,SignalDelay+0);
       bluewave=iCustom(symbols[i]+suffix,RunTF,"HGI_v16.09",  7,SignalDelay+0);
      
      }//wave
      
      
      
      
      
      //==============================================
        string Sym = StringSubstr(symbols[i]+suffix,3,3);
         string Symbegin = StringSubstr(symbols[i]+suffix,0,3);
         
            if ((Sym=="JPY" || Symbegin=="XAU") && (Digits == 3  || Digits==5)){
                pipPoint=0.001;
            }else if((Sym=="JPY" || Symbegin=="XAU") && Digits == 2 ||Digits == 4) {
                pipPoint=0.01;
            }else {
                   pipPoint=Point;
            }
            
    //=================================================================================
    
     /* if (UseClose2MA_Filter){
         isWithinTradeZone=false;
         currentdist=0;
         
         
          
            
         
         
         atr1= iATR (symbols[i]+suffix,RunTF,atr_period,SignalDelay+0);
         ma1=iMA(symbols[i]+suffix,RunTF,120,0,MODE_LWMA,PRICE_CLOSE,SignalDelay+0);
         close = iClose(symbols[i]+suffix,RunTF,SignalDelay+0);
    
         if (useManualPip)
         {
            MinPriceDist=ATRdistMUL*manualATRdist;
         } 
         else
         {
            MinPriceDist= ATRdistMUL*(atr1/pipPoint);
         }
         
       
         double currentdist = (MathAbs(close-ma1))/pipPoint;
         
         if (currentdist<=MinPriceDist) isWithinTradeZone=true;
         
      }//useclosema filter
      
      
      
      */
      
   //===============================================================================
               double MinDist2move;
               MinDist2move= GridPips*pipPoint*multiplier;
                close = iClose(symbols[i]+suffix,RunTF,SignalDelay+0);
               // MinDist2move > MathAbs(LastOrderPrice-close)
            //---------------------
                if((   MathAbs(LastOrderPrice()-close)>=MinDist2move && ExistPositions()) || !ExistPositions()){
                  
                     ExceedMinDist =true;
               
               }else {
               
                     ExceedMinDist =false;
               }
            //---------------------
            
      
      //===========================================
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
   /*
      if (b1 != EMPTY_VALUE && b12 !=EMPTY_VALUE)
      {
         Alert ("YOur account have been credited wit BUY BUY BUY BUY");
      }
  
 
      if (s1 != EMPTY_VALUE && s12 !=EMPTY_VALUE)
      {
      Alert ("YOur account have been credited wit SELL SELL SELL SELL");
      }
  
  */
      bool checksignal=true;
      signal = NONE;
   if (checksignal){
         if (TradeTrend==true ) {
            
            if ( trendbuy!= EMPTY_VALUE && ExceedMinDist ==true ) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (trendsell != EMPTY_VALUE && ExceedMinDist ==true  )
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
           
               } 
         
          GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
         
          if (TradeRange) {
            
            if ( rangebuy != EMPTY_VALUE&& ExceedMinDist ==true ) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (rangesell != EMPTY_VALUE && ExceedMinDist ==true )
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
            } 
         GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
          
          if (TradeRad) {
            
            if ( radbuy != EMPTY_VALUE && ExceedMinDist ==true) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (radsell != EMPTY_VALUE  && ExceedMinDist ==true)
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
         } 
         
          GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
         
          if (TradeWave) {
            
            if (  yellow_wave!= EMPTY_VALUE&& ExceedMinDist ==true ) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (bluewave != EMPTY_VALUE && ExceedMinDist ==true )
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
         } 
      
          GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
      
      }//check signal 
      
      
      
      
      
   }//for loop
}//on timer




//==================================================
         double LastOrderPrice(){
         for(int i=OrdersTotal();i>=0;i--){
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
               if(/*OrderMagicNumber()==MagicNos && */ OrderSymbol()==symbols[i]+suffix){
               return(OrderOpenPrice());
               }
             }
          return(0);
           }
  
  //=======================================
  
  bool ExistPositions() 
  {
     for(int i=0; i<OrdersTotal(); i++) 
     {
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
        {
           if (OrderSymbol()==symbols[i]+suffix ) 
           {
            return(True);
           }
        }
     }
   return(false);
  }
  
  //====================================