//+------------------------------------------------------------------+
//|                                             PIN_SuperTrendv2.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#include "PIN.mqh"
Pin * pins[28];
  string symbols[] = { "GBPJPY", "GBPCHF", "EURGBP","GBPCAD" };
extern int SignalPin= 1; // EAX signal pin

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   for( int i=0;i<3;i++ )
   pins[i] = new Pin( symbols[i], 1 );
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int limit, i, flag, flagh, trend[5000];
   double up[5000], dn[5000], medianPrice, atr;
   int counted_bars = IndicatorCounted();


  {
//---
for( int i=0; i<3; i++ )
	pins[i].set(SuperTrend(pin(i))); 

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

int pin( int i ) {
  double price[2];

   price[0] = Close[i];
   price[1] = up[i+1];
   price[2] = dn[i+1];

	if ( price[ 0 ] > price[ 1 ] )
		return( 1 );
	if ( price[ 0 ] < price[ 2 ] )
		return( 2 );

return( 0 );
}
